% Teststoch max. eig. minimization code
addpath('../../../Data');
if 0
load CovColon
cov=covcolon;
n=500;
end

if 0
load covcolarge
n=2000;
[s,idx]=sort(diag(covcolarge),'descend');
cov=covcolarge(idx(1:n),idx(1:n));
end

if 1
load covmedium
n=300;
[s,idx]=sort(diag(covmedium),'descend');
cov=covmedium(idx(1:n),idx(1:n));
end

if 1
% Generate data
kconst=8;
Amat=zeros(2*kconst,n^2);
bvec=[];cvec=[];
for i=1:kconst
   rmat=rand(n,n);rmat=(rmat'+rmat)/2;
   rvec=[vec(rmat)/norm(rmat)];
   Amat(i,:)=rvec';
end
% Remove first eigenvectors
% matin=cov/norm(cov);
% for i=1:kconst
%     [u,sigma]=lmaxeig(matin);
%     Amat(kconst+i,:)=vec(u*u')';
%     matin=matin-sigma*u*u';
% end
% kconst=2*kconst;
% Constant and objective vector
bvec=[bvec;zeros(kconst,1)];
%cvec=[1;1;zeros(n^2,1)];
cvec=vec(cov/norm(cov));
cvec=-cvec;Amat=-Amat;
end


% ***** Algo parameters *****
maxiter=1000;
checkf=20;
B=1e+2;
rand('state',25);
ps=0.2;
alpha=0.10; %0.25 good
rand('state',11);c=floor(ps*n);rv=rand(1,c);

% For Debug
%load AmatSample
%maxiter=500;

if 0 % Approx subgradient MATLAB code with columnwise subsampling
profile on
tic
[ovals3,movals3,avx3,ogap3]=ColStochGrad(Amat,bvec,cvec,n,maxiter,alpha,ps,B,checkf);
toc
profile off
end

if 1 % Approx subgradient C code with columnwise subsampling
tic
[avx1,ovals1,movals1,ogap1]=ColSampGrad(Amat',bvec,cvec,B,ps,alpha,maxiter,checkf);
movals1=movals1(find(movals1));
ogap1=ogap1(find(ogap1))/ogap1(1);
toc
end

if 1 % Deterministic subgradient C code
tic
[avx4,ovals4,movals4,ogap4]=DetGrad(Amat',bvec,cvec,B,alpha,maxiter,checkf);
movals4=movals4(find(movals4));
ogap4=ogap4(find(ogap4))/ogap4(1);
toc
end

if 0 % Deterministic subgradient MATLAB code
tic
[ovals2,y,avx2,cpuhist,movals2,ogap2]=DetStochGradLM(Amat,bvec,cvec,maxiter,checkf,alpha,B,-Inf);
movals2=movals2(find(movals2));
toc
end


if 0
it=(0:checkf)*(maxiter/checkf);    
semilogy(it,ogap1,'-bo',it,ogap4,'-ks','LineWidth',3,'MarkerSize',12,'MarkerFaceColor','w')
plot(it,movals1,'-bo',it,movals4,'-ks','LineWidth',3,'MarkerSize',12,'MarkerFaceColor','w')
end


if 0
[movals1,movals4]    
%[min(movals),min(maovals)]
mtst=eig(matin);
%vobj=real(mtst(1));
vobj=min(ovals4);
it=(0:checkf)*(maxiter/checkf);
semilogy(0:maxiter,abs(ovals1-vobj),':b',0:maxiter,ovals2-vobj,'k','Linewidth',2);hold on;
semilogy(it,movals1-vobj,'-bo',it,movals2-vobj,'-ks','Linewidth',3,'MarkerSize',10);hold off;
set(gca,'FontSize',16);
xlabel('iter');ylabel('oval');axis([ 0 maxiter 1e-3 1.5]);
end


if 0
[movals3,movals2]    
%[min(movals),min(maovals)]
mtst=eig(matin);
vobj=real(mtst(1));
it=(0:checkf)*(maxiter/checkf);
semilogy(0:maxiter,abs(ovals3-vobj),':b',0:maxiter,ovals2-vobj,'k','Linewidth',2);hold on;
semilogy(it,movals3-vobj,'-bo',it,movals2-vobj,'-ks','Linewidth',3,'MarkerSize',10);hold off;
set(gca,'FontSize',16);
xlabel('iter');ylabel('oval');axis([ 0 maxiter 1e-3 1.5]);
end


if 0
% Test using SEDUMI
K.s=n;
[xs,ys]=sedumiscp(Amat,bvec,cvec,B,n);
[us,sigmas]=maxeig(reshape(Amat'*ys(1:kconst)-cvec,n,n));
sval=sigmas-bvec'*ys(1:kconst);
end

% ========================== Older columnwise code ===============================

if 0
tic
% Launch subgradient code
y=zeros(size(Amat,1),1);yav=y;ovals=[];movals=[];
hv=alpha/sqrt(maxiter);ogap=[];
for k=0:maxiter
    % Compute gradient
    [u,sigma]=lmaxeig(reshape(Amat'*y-cvec,n,n));
    grad=Amat*vec(u*u')-bvec;
    % Record function value
    ovals=[ovals,sigma-bvec'*y];
    %ogap=[ogap;(abs(sigma)-bvec'*y)-dualvalue(Amat,bvec,cvec,vec(u*u'),B)];
    % Take step
    y=y-hv*grad;
    % Project
    y=y/max(1,norm(y)/B);
    % Compute average
    yav=(k*yav+y)/(k+1);
    if mod(k,checkf)==0
        [u,sigma]=lmaxeig(reshape(Amat'*yav-cvec,n,n));
        movals=[movals;[k,sigma-bvec'*yav]];
    end
end
toc
%movals=diag(1./(1:maxiter))*tril(ones(maxiter,maxiter))*ovals';
end


if 0
tic
% Launch approx subgradient code
y=zeros(size(Amat,1),1);yav=y;aovals=[];maovals=[];
hv=alpha/sqrt(maxiter);
for k=0:maxiter
    % Compute gradient
    %mapp=LowMCapprox(reshape(Amat'*y-cvec,n,n),ps);
    mapp=SampMat(Amat'*y-cvec,ps); 
    %[u,sigma]=lmaxeig(mapp);
    [u,sigma,nconv]=SpMaxEig(mapp,1,1,1e-6,300);
    umv=vec(u*u');idnz=find(mapp);
    grad=Amat(:,idnz)*umv(idnz)-bvec;
    % Record function value
    aovals=[aovals,sigma-bvec'*y];
    % Take step
    y=y-hv*grad;
    % Project
    y=y/max(1,norm(y)/B);
    % Compute average
    yav=(k*yav+y)/(k+1);
    if mod(k,checkf)==0
        [u,sigma]=lmaxeig(reshape(Amat'*yav-cvec,n,n));
        maovals=[maovals;[k,sigma-bvec'*yav]];
    end
end
toc
%maovals=diag(1./(1:maxiter))*tril(ones(maxiter,maxiter))*aovals';
minaovals=min(diag(aovals)*triu(ones(maxiter+1,maxiter+1))+1e+100*tril(ones(maxiter+1,maxiter+1),-1));
end


if 0
tic
% Launch subgradient code
y=zeros(size(Amat,1),1);yav3=y;ovals3=[];movals3=[];
hv=alpha/sqrt(maxiter);ogap=[];
for k=0:maxiter
    % Compute gradient
    [u,sigma]=lmeig(reshape(Amat'*y-cvec,n,n));
    grad=sign(sigma)*Amat*vec(u*u')-bvec;
    % Record function value
    ovals3=[ovals3,abs(sigma)-bvec'*y];
    %ogap=[ogap;(abs(sigma)-bvec'*y)-dualvalue(Amat,bvec,cvec,vec(u*u'),B)];
    % Take step
    y=y-hv*grad;
    % Project
    y=y/max(1,norm(y)/B);
    % Compute average
    yav3=(k*yav3+y)/(k+1);
    if mod(k,checkf)==0
        [u,sigma]=lmeig(reshape(Amat'*yav3-cvec,n,n));
        movals3=[movals3;[k,abs(sigma)-bvec'*yav3]];
    end
end
toc
%movals=diag(1./(1:maxiter))*tril(ones(maxiter,maxiter))*ovals';
end