function [ovals,y,yav,cpuhist,movals,ogap]=DetStochGradLM(Amat,bvec,cvec,maxiter,checkf,alpha,B,target)
n=sqrt(size(Amat,2));
Nperiod=floor(maxiter/checkf);
% Launch subgradient code
[u,sigma0]=lmeig(reshape(-cvec,n,n));sigmaa=+Inf;tic;cpuhist=[];
y=zeros(size(Amat,1),1);yav=y;ovals=[];movals=[];
hv=alpha/sqrt(maxiter);ogap=[];
for k=0:maxiter
    % Compute gradient
    covm=reshape(Amat'*y-cvec,n,n);
    [u,sigma]=lmeig(covm);
    swsgn=sign(u'*covm*u);
    grad=swsgn*Amat*vec(u*u')-bvec;
    % Record function value
    ovals=[ovals,sigma-bvec'*y];
    % Take step
    y=y-hv*grad;
    % Project
    y=y/max(1,norm(y)/B);
    % Compute average
    yav=(k*yav+y)/(k+1);
    % Gap
    ogap=[ogap;(abs(sigma)-bvec'*yav)-dualvalue(Amat,bvec,cvec,vec(u*u'),B)];
    if mod(k,Nperiod)==0
        [u,sigmaa]=lmeig(reshape(Amat'*yav-cvec,n,n));
        movals=[movals;sigmaa-bvec'*yav];
    end
    cpuhist=[cpuhist;toc];
    % Gap
    ogap=[ogap;(abs(sigma)-bvec'*yav)+cvec'*vec(u*u')+B*norm(Amat*vec(u*u')-bvec)];
    if ogap<0
        disp('Gap precision issue')
    end
    % Check progress
    if mod(k,Nperiod)==0
        [u,sigmaa]=lmeig(reshape(Amat'*yav-cvec,n,n));
        movals=[movals;sigmaa-bvec'*yav];
        disp(sprintf('Iteration: %d',k));
    end
end