% Teststoch max. eig. minimization code
addpath('../Data');
addpath('../');

if 0
load covmedium
[s,idx]=sort(diag(covmedium),'descend');
end


% Sample parameters
ns=[500,1000];
nsamp=2;
improv=0.5;


% ***** Algo parameters *****
maxiter=500;
checkf=10;
B=1e+2;
ps=0.2;
alpha=1;
rand('state',11);
% ***************************


res=[];
for n=ns
    for ii=1:nsamp
        covm=covmedium(idx(1:n),idx(1:n));
        % Generate data set
        kconst=1;
        Amat=zeros(2*kconst,n^2);
        bvec=[];cvec=[];
        for i=1:kconst
            rmat=rand(n,n);rmat=(rmat'+rmat)/2;
            rvec=[vec(rmat)/norm(rmat)];
            Amat(i,:)=rvec';
        end
        % Remove first eigenvectors
        matin=covm/norm(covm);
        for i=1:kconst
            [u,sigma]=lmaxeig(matin);
            Amat(kconst+i,:)=vec(u*u')';
            matin=matin-sigma*u*u';
        end
        kconst=2*kconst;
        % Constant and objective vector
        bvec=[bvec;zeros(kconst,1)];
        cvec=vec(covm/norm(covm));
        cvec=-cvec;Amat=-Amat;
        % Launch codes. 
        disp('Deterministic gradient')
        tic;[avx4,ovals4,movals4,ogap4,cput4]=DetGrad(Amat',bvec,cvec,B,alpha,maxiter,checkf,0);t2=toc;
        idx4=find(ogap4);movals4=movals4(find(movals4));ogap4=ogap4(find(ogap4))/ogap4(1);
        disp('Subsampled gradient')
        tic;[avx1,ovals1,movals1,ogap1,cput1]=ColSampGrad(Amat',bvec,cvec,B,ps,alpha,maxiter,checkf,min(movals4));t1=toc;
        idx1=find(ogap1);movals1=movals1(find(movals1));ogap1=ogap1(find(ogap1))/ogap1(1);
        res=[res;[n,t1,t2]];
    end
end


cpu1=reshape(res(:,2),nsamp,length(ns));
cpu2=reshape(res(:,3),nsamp,length(ns));
[median(cpu1);median(cpu2)]



if 0
    it=(0:checkf)*(maxiter/checkf);
    semilogy(cput1(idx1),ogap1,'-bo',cput4(idx4),ogap4,'-ks','LineWidth',3,'MarkerSize',12,'MarkerFaceColor','w')
    plot(cput1(idx1),movals1,'-bo',cput4(idx4),movals4,'-ks','LineWidth',3,'MarkerSize',12,'MarkerFaceColor','w')
    plot(0:maxiter,ovals1,'-b',0:maxiter,ovals4,'-k','LineWidth',3,'MarkerSize',12,'MarkerFaceColor','w')
end


