% Teststoch trace norm minimization
addpath('../');


% Sample parameters
rand('state',1);
ns=[100,200,500];
%ns=[20];
nsamp=10;
r=3;
nrts=4;
observ=0.3;
improv=1e-1;


% ***** Algo parameters *****
maxiter=5000;
checkf=10;
ps=0.5;
alpha=1;
B=10;
rnk=4;
iterfac=2*floor(1/ps);
rand('state',11);
% ***************************



res=[];
for n=ns
    for ii=1:nsamp
        % Generate sample ratings data
        U=round(sqrt(nrts)*rand(n,r));
        Aorig=U*U';
        tidx=find(triu(ones(n,n)));
        obidx=tidx(randperm(length(tidx)));obidx=obidx(1:floor(observ*length(tidx)/2));
        A=zeros(n,n);A(obidx)=Aorig(obidx);A=A+tril(A',-1);As=sparse(A);
        disp('Deterministic gradient')
        [X2,Xav2,ovals2,movals2,gaps2,cput2]=DetTraceNorm(As,rnk,B,alpha,maxiter,checkf,0);
        idx2=find(movals2);movals2=movals2(find(movals2));
        disp('Subsampled gradient')
        [X1,Xav1,ovals1,movals1,gaps1,cput1]=ColTraceNorm(As,rnk,B,ps,alpha,maxiter*iterfac,checkf,min(movals2));
        idx1=find(movals1);movals1=movals1(find(movals1));
        % Record results
        res=[res;n,max(cput1),max(cput2)];
        disp('**********************************************************************************');
        disp([n,max(cput2)/max(cput1),res(end,:),ii]);
        disp('**********************************************************************************');
    end
end

cpu1=reshape(res(:,2),nsamp,length(ns));
cpu2=reshape(res(:,3),nsamp,length(ns));
[ns',median(cpu2)',median(cpu1)',median(cpu2)'./median(cpu1)']

latex([ns',median(cpu2)',median(cpu1)',median(cpu2)'./median(cpu1)'],'%.2e')

save ResCollab
clear mex