% Test Subsampling quality versus sampling rate

addpath('../Data');
addpath('../');

n=500;

if 0 % Get Colon matrix
load CovColon
covt=covcolon;
n=500;
end

if 0
load covcolarge
n=2000;
[s,idx]=sort(diag(covcolarge),'descend');
covt=covcolarge(idx(1:n),idx(1:n));
end

if 1
% Parameters    
nsamp=20;
srates=[0.005:0.01:0.25];
bfac=1/n;
r=3;
confl=0.01;
eta=1+sqrt(8*log(1/confl));
maxit=700;
tol=1e-6;

res=[];
for ps=srates
    for s=1:nsamp
        c=floor(ps*n);
        %[V,R]=qr(randn(n,n));covt=V*diag(betarnd(bfac*r,1,n,1))*V'; % Random matrix 
        tic;[sigmav,vv]=SampSpectralNorm(covt,ps,maxit,tol);t1=toc;
        tic;[v2,truesig,nconv]=LmEigArp(covt,1,1,tol,maxit);t2=toc;
        %tic;[v2,truesig]=lmeig(covt);t2=toc;
        numr=norm(covt,'fro')^2/truesig^2;
        res=[res;sigmav,truesig,ps,c,t1,t2,vv'*covt*vv];
    end
end

% Aggregate stats
resm=reshape(res(:,6)./res(:,5),nsamp,length(srates));

% Plot results
plot(srates,median(resm),'-bo','LineWidth',3,'MarkerSize',10,'MarkerFaceColor','w');hold on;
%plot(res(:,3),res(:,6)./res(:,5),'.b','MarkerSize',12)
set(gca,'FontSize',16);xlabel('sratio');ylabel('speedup');
axis([0 max(srates)+0.01 0 1.1*max(median(resm))]);
plot([0 max(srates)+0.01],[1 1],':k','LineWidth',4);hold off;

end