% Test Subsampling quality versus sampling rate

addpath('../Data');
addpath('../');

n=500;

if 0 % Get Colon matrix
load CovColon
covt=covcolon;
n=500;
end


if 1
% Parameters    
nsamp=10;
srates=10.^(-2:0.05:-0.2);
bfac=1/n;
r=3;
confl=0.01;
eta=1+sqrt(8*log(1/confl));

% Eig decomposition of orig. matrix
[V,D]=eig(covm);
[d,idx]=sort(diag(D),'Descend');
dbis=diag(D);dbis=dbis(randperm(n));

res=[];
for ps=srates
    for s=1:nsamp
        c=floor(ps*n);
        %[V,R]=qr(randn(n,n));covt=V*diag(betarnd(bfac*r,1,n,1))*V'; % Random matrix 
        pp=sum(covt.^2)'/norm(covt,'fro')^2;
        cp=PartialSum(pp);
        rv=rand(1,c);
        idxc=[];
        for i=1:c
            idxc=[idxc,min(find(rv(i)<=cp))];
        end
        C=covt(:,idxc)*diag(1./sqrt(c*pp(idxc)));
        Sm=C'*C;
        %[vv,sigmav]=maxeig(Sm);
        [vv,sigmav]=lmeig(Sm);
        [v2,truesig]=lmeig(covt);
        numr=norm(covt,'fro')^2/truesig^2;
        res=[res;sqrt(sigmav),truesig,r,numr,c,];
    end
end

% Check relative error
errv=sqrt((res(:,1)-res(:,2)).^2./res(:,2).^2);
ixnz=find(errv./(eta*res(:,4))>1e-4); % Remove outliers with very small error
% Get coefficient of regression and ratio theor/empirical
theoerr=eta*res(:,4)/sqrt(c);
erratio=sqrt(errv)./theoerr;
Am=[1./sqrt(res(ixnz,5)),ones(length(ixnz),1)];
beta=Am\(errv(ixnz)./(eta*res(ixnz,4)));
shft=beta(1);
if 0
bmt=[];cvals=unique(res(:,5));
for i=1:length(cvals)
    idx=find(res(:,5)==cvals(i));
    bmt=[bmt,errv(idx)./(eta*res(idx,4))];
end
%bmt1=bmt;
%bmt2=bmt;
loglog(cvals,mean(bmt),'-','LineWidth',3);hold on;
loglog(cvals,mean(bmt)+std(bmt),':k',cvals,mean(bmt)-std(bmt),':k','LineWidth',3);
end
if 1
% Plot results
loglog(res(ixnz,5),errv(ixnz)./(eta*res(ixnz,4)),'.','MarkerSize',12);hold on;
loglog(res(ixnz,5),shft./sqrt(res(ixnz,5)),'LineStyle','--','Linewidth',4,'Color',[0 0 0])
axis([0.9*min(res(ixnz,5)) 1.1*max(res(ixnz,5)) 0.5*min(errv(ixnz)./(eta*res(ixnz,4))) 1.5*max(errv(ixnz)./(eta*res(ixnz,4)))]);hold off;
set(gca,'FontSize',16);xlabel('srate');ylabel('sqrelerr');
end
end


% Do another plot of precision w.r.t sampling rate !!! 