function [X,Xav,ovals]=StochGradSumKLarg(Amat,rnk,maxiter,alpha,ps,B,checkf,stoch)
n=size(Amat,1);
%X=Amat;Xav=X;
maovals2=[];ovals=[];
hv=alpha/sqrt(maxiter);
Nperiod=floor(maxiter/checkf);
c=floor(ps*n);
B=max(Amat(:))+1;
% Initialize X
X=ones(n,n);Xav=X;
X(find(Amat))=Amat(find(Amat));
X(find(X<0))=zeros(sum(X(:)<0),1);
X(find(X>B))=B*ones(sum(X(:)>B),1);
for k=0:maxiter
    % Compute approx eigenvector
    covm=X;
    if stoch
        pp=sum(covm.^2)'/norm(covm,'fro')^2;
        cp=cumsum(pp);
        rv=rand(1,c);
        idxc=[];
        for i=1:c
            idxc=[idxc,min(find(rv(i)<=cp))];
        end
        C=covm(:,idxc)*diag(1./sqrt(c*pp(idxc)));
        Sm=C'*C;
        [U,sigmav,sgn]=lmeig(Sm,rnk);
        up=C*U*diag(1./sqrt(abs(sigmav)));sigma=sqrt(abs(sigmav));
        mbuf=X*up;mbuf=up.*mbuf;sgn=sign(sum(mbuf)+1e-15);
    else
        [U,S,V]=svd(X);up=V(:,1:rnk);sigma=diag(S);sigma=sigma(1:rnk);
        mbuf=X*up;mbuf=up.*mbuf;sgn=sign(sum(mbuf)+1e-15);
    end
    grad=up*diag(sgn)*up';
    % Record function value
    ovals=[ovals,sum(sigma)];
    % Take step
    X=X-hv*grad;
    % Project
    X(find(Amat))=Amat(find(Amat));
    X(find(X<0))=zeros(sum(X(:)<0),1);
    X(find(X>B))=B*ones(sum(X(:)>B),1);
    % Compute average
    Xav=(k*Xav+X)/(k+1);
    % Gap
    nz=find(abs(Amat)>0);zz=find(abs(Amat)==0);
    gapv=sum(svd(X))-(B*sum(min([zeros(1,length(zz));grad(zz)']))+trace(grad*Amat));
    % Check progress
    if mod(k,Nperiod)==0
        disp(sprintf('Iteration: %d   Gap: %.2e',k,gapv));
    end
end